%  harvest1.m
% Matlab file for Part 1 of the Harvesting an Age-
% Distributed Population module

disp('*********************************************')
disp('Part 1:  Sustainable harvesting ')
disp('*********************************************')
disp('  ')    

    format short
    
    disp('Step 1:')
    disp('We define the Leslie matrix L.  First we define')
    disp('symbolic variables a1, a2, ... ,a12 and put them ')
    disp('into the first row of L.  Then we put the symbolic')
    disp('variables b1, b2, ... ,b11 on the sub-diagonal')
    disp('using a ''for'' loop.')
    disp(' ')
    disp('Make your window wide so you can fully display L.')
    disp(' ')
    disp('Enter: ')
    disp(' ')
    disp('  syms a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 ')
    disp('  syms b1 b2 b3 b4 b5 b6 b7 b8 b9 b10 b11 ')
    disp('  a=[a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12]; ')
    disp('  b=[b1 b2 b3 b4 b5 b6 b7 b8 b9 b10 b11]; ')
    disp(' ')
    disp('  L(1,:) = a; ')
    disp('  for i=2:12 ')
    disp('     L(i,:) = zeros(1,12); ');
    disp('     L(i,i-1) = b(i-1); ')
    disp('  end ')
    disp('  L ')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')

    keyboard;
    disp(' ')

    disp('----------------------------------------------')
    disp('Step 1 (cont.): ')
    disp('Now we define the diagonal matrix H with components ')
    disp('h1, h2, ... , h12 on its diagonal and then compute ')
    disp('(I-H)*L to check that it is also has the form of a ')
    disp('Leslie matrix. ')
    disp(' ')
    disp('Enter: ')
    disp(' ')
    disp('  syms h1 h2 h3 h4 h5 h6 h7 h8 h9 h10 h11 h12 ')
    disp('  H=diag([h1 h2 h3 h4 h5 h6 h7 h8 h9 h10 h11 h12]); ')
    disp('  (eye(12)-H)*L ')
    disp(' ')
    disp('----------------------------------------------')
    disp('Describe the pattern you see in the components ')
    disp('of (I-H)*L.  Is it a Leslie matrix? ')
    disp('Use MATLAB comments in your diary file. ')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')

    keyboard;
    disp(' ')

    disp('----------------------------------------------')
    disp('Step 2: ')
    disp('The following MATLAB commands find the ')
    disp('characteristic polynomial pfun(lam) of L and ')
    disp('construct the auxiliary function qfun(lam).')
    disp(' ')
    disp('Enter: ')
    disp(' ')
    disp('  syms lam ')
    disp('  pfun=det( L - lam*eye(12) ) ')
    disp('  pretty(pfun)    % Gives nice display ')
    disp(' ')
    disp('  c=a;     % Just makes c a symbolic array')
    disp('  qfun=a(1)/lam; ')
    disp('  c(1)=1; ')
    disp('  for i=2:12 ')
    disp('    c(i) = c(i-1)*b(i-1); ')
    disp('    qfun = qfun + a(i)*c(i)/lam^i; ')
    disp('  end ')
    disp('  qfun ')
    disp('  pretty(qfun) ')
    disp(' ')
    disp('----------------------------------------------')
    disp('If the Leslie matrix were (I-H)*L instead of L,')
    disp('write enough of the condition q(1)=1 down on paper ')
    disp('to convince yourself that you get a very ')
    disp('complicated equation in the 12 unknowns')
    disp('h1, h2, ... , h12 that can be satisfied by many')
    disp('different choices of the h''s. ')
    disp('Discuss using MATLAB comments in your diary file. ')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')

    keyboard;
    disp(' ')

    disp('---------------------------------------------------')
    disp('Step 3: ')
    disp('Now we assign values to the parameters of the model')
    disp('for New Zealand sheep and compute the dominant')
    disp('eigenvalue of L.')
    disp(' ')
    disp('Enter: ')
    disp(' ')
    disp('  a1=0; a2=0.045; a3=0.391; a4=0.472; a5=0.484; ')
    disp('  a6=0.546; a7=0.543; a8=0.502; a9=0.468; a10=0.459; ')
    disp('  a11=0.433; a12=0.421; ')
    disp('  b1=0.845; b2=0.975; b3=0.965; b4=0.950; b5=0.926; ')
    disp('  b6=0.895; b7=0.850; b8=0.786; b9=0.691; ')
    disp('  b10=0.561; b11=0.370; ')
    disp('  L=double( subs(L) ) ')
    disp('  eigvals=eig(L) ')
    disp('  lam1=eigvals(1) ')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')

    keyboard;
    disp(' ')

    disp('----------------------------------------------')
    disp('Step 4: ')
    disp('Compute the value of h for a uniform harvesting ')
    disp('policy using the formula h = 1 - 1/lam1.')
    disp(' ')
    disp('Explain how one can derive the formula.  Discuss the')
    disp('significance of the h value you found relative to')
    disp('the sheep population.')
    disp('Use MATLAB comments in your diary file.')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')

    keyboard;
    disp(' ')

    disp('----------------------------------------------')
    disp('Step 5: ')
    disp('Explain why the harvest rate is not the same as the ')
    disp('growth rate of approximately 17.6%. ')  
    disp(' ')
    disp(' ')
    disp('----------------------------------------------')
    disp('To go on to part 2 of this module, ')
    disp('type: harvest2.')
    disp(' ')